from pyramid.config import Configurator
from repoze.zodbconn.finder import PersistentApplicationFinder
from pybookbuilder.resources import appmaker


class NonPersistentApplicationFinder(PersistentApplicationFinder):

    def __call__(self, environ):
        app = self.appmaker({})
        return app


def main(global_config, **settings):
    """ This function returns a Pyramid WSGI application.
    """
    zodb_uri = settings.get('zodb_uri')
    if zodb_uri is None:
        finder_class = NonPersistentApplicationFinder
    else:
        finder_class = PersistentApplicationFinder
    finder = finder_class(zodb_uri, appmaker)
    def get_root(request):
        return finder(request.environ)
    config = Configurator(root_factory=get_root, settings=settings)
    config.add_static_view('static', 'pybookbuilder:static')
    config.add_static_view('static_deform', 'deform:static')
    config.add_translation_dirs('pybookbuilder:locale')
    config.scan('pybookbuilder')
    return config.make_wsgi_app()
