# Hi. This file is for app-wide util functions.

from docutils.core import publish_string as publish_rst_string
from lxml import etree
from pkg_resources import resource_stream
from StringIO import StringIO
from time import time

def get_default_file(fname):
    return resource_stream('pybookbuilder', 'default_files/'+fname)

def choose_name(objname, folder):
    name = ''
    while not name or name in folder:
        name = str(hash(time()))[-6:] # What now?!

    return name

def extract_title(rstdata):
    """ Extract the title of a reStructuredText document. """
    htmldata = publish_rst_string(rstdata, writer_name='html')
    parser = etree.HTMLParser()
    tree = etree.parse(StringIO(htmldata), parser)
    return tree.xpath('/html/head/title')[0].text
